/*
 *  gui_main.h
 *
 *  Copyright (c) 2001-2017 Nick Dowell
 *
 *  This file is part of amsynth.
 *
 *  amsynth is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  amsynth is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with amsynth.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <string>

class GenericOutput;
class Synthesizer;

void gui_kit_init(int *argc, char ***argv);

void gui_kit_run(unsigned (*timer_callback)());

void gui_init(Synthesizer *, GenericOutput *);

void gui_dealloc();

void ShowModalErrorMessage(const std::string & msg, const std::string & secondaryText = "");

#if defined(__linux)

void spawn_new_instance();

#endif
